#include "STC8h.h"
#include "uart.h"
#include "delay.h"
#include "vl53l0x.h"
#include "stdio.h"
#include "i2c.h"
#include "IR_RED.h"
#include "eeprom.h"
#include "tm1638.h"
/*******************函数声明**/
void  gpio_init();
void io_scan();
void out_init();  //输出初始化
void sys_init();
xdata unsigned char buf[30];
xdata unsigned int val = 0;
xdata u8  ir_data[4]={0};//红外解码
xdata u8  sys_mode=0;//系统当前状态
xdata u8  ir_hex_str[20]={0};
xdata u16 distance_sum=0;
xdata u16 distance_buff[15]={0};
xdata u8 distacne_index=0;
xdata u8 distance_fill_f=0;
xdata u16 distance_sub=0;
void main()
{
	 i2cinit();
   sys_init();  //系统初始化
	 UartInit();
	 PWMA_INIT();
	 move_read_byte(Eeprom_Read_Addr,sizeof(save_list),(u8 *)&NEC_save_data);  //读取保存数据
	 NEC_data_manage();
	 UartSendStr("hello_world\r\n");
	 delay_ms(200);
	//以下分别读0xc0,0xc1,0xc2寄存器的值，读出来应该是0xEE,0xAA,0x10
	val = VL53L0X_Read_Byte(IDENTIFICATION_REVISION_ID-2);
	sprintf(buf,"c0=%x\r\n",val);
	UartSendStr(buf);
	val = VL53L0X_Read_Byte(IDENTIFICATION_REVISION_ID-1);
	sprintf(buf,"c1=%x\r\n",val);
	UartSendStr(buf);
	val = VL53L0X_Read_Byte(IDENTIFICATION_REVISION_ID);
	sprintf(buf,"c2=%x\r\n",val);
	UartSendStr(buf);
	VL53L0X_init(1);
	startContinuous(0);
	

	 while(1)
	 {
		u8 i;
		val = readRangeContinuousMillimeters();
		//滤波 
		 distance_sum=0;
		if(distance_fill_f==0)
		{
			if(val<500)
			{
				distance_buff[distacne_index]=val-40;
				distacne_index++;
				for(i=0;i<distacne_index;i++)
				{
					distance_sum=distance_sum+distance_buff[i];
				}
				distance_sub=distance_sum/distacne_index;//平均值
				if(distacne_index==15)
				{
					distance_fill_f=1;
					distacne_index=0;
				}
			}
		}
		else
		{
			if(val<500)
			{
				distance_buff[distacne_index]=val-40;
				distacne_index++;
				distance_sum=0;
				for(i=0;i<15;i++)
				{
					distance_sum=distance_sum+distance_buff[i];
				}
				distance_sub=distance_sum/15;//平均值
				if(distacne_index==15)
				{
					distacne_index=0;
				}
			}
		}
		
		sprintf(ir_hex_str,"%04d",distance_sub);
		 for(i=0;i<4;i++)
			 {
				 if(ir_hex_str[i]>=48&&ir_hex_str[i]<=57)
				 {
					 tm1638_show_buff[i]=tab[ir_hex_str[i]-48];
				 }
				 else
				 {
					 tm1638_show_buff[i]=tab[ir_hex_str[i]-65+10];
				 }
			 } 
    I2C_USE_P24P25();
		tm1638_write_display(tm1638_show_buff);
		I2C_USE_P14P15(); 	 
		delay_ms(10); 
		 if(B_IR_Press)
		 {
			u8 i=0;
			B_IR_Press=0;
			flow_index=0;
		   ir_data[0]=((u8 *)&RmtNec)[0];
			 ir_data[1]=((u8 *)&RmtNec)[1];
			 ir_data[2]=((u8 *)&RmtNec)[2];
			 ir_data[3]=((u8 *)&RmtNec)[3];
			 sprintf(ir_hex_str,"%02X%02X%02X%02X\r\n",RmtNec);
			 for(i=0;i<4;i++)
			 {
				 if(ir_hex_str[i]>=48&&ir_hex_str[i]<=57)
				 {
					 tm1638_show_buff[i]=tab[ir_hex_str[i]-48];
				 }
				 else
				 {
					 tm1638_show_buff[i]=tab[ir_hex_str[i]-65+10];
				 }
			 }
			 	I2C_USE_P24P25();
				tm1638_write_display(tm1638_show_buff);
				I2C_USE_P14P15(); 
		 }
	 }
  
}
void timer0_inter()  interrupt 1       //t0定时器中断
{
  
}
void  INIT0()  interrupt 0   //外部中断
{
	    
			
}
void  gpio_init()
{

}
void io_scan()   //执行按键
{

}


void sys_init()
{
    P_SW2 |= 0x80;     //扩展寄存器(XFR)访问使能

    P0M1 = 0x00;   P0M0 = 0x00;   //设置为准双向口
    P1M0 = 0x3f; P1M1 = 0x3f; 
    P2M1 = 0x30;   P2M0 = 0x30; 
    P3M1 = 0x04;   P3M0 = 0x04;   //设置为准双向口  
    P4M1 = 0x14;   P4M0 = 0x00;   //设置为准双向口
    P5M1 = 0x00;   P5M0 = 0x00;   //设置为准双向口
    P6M1 = 0x00;   P6M0 = 0x00;   //设置为准双向口
    P7M1 = 0x00;   P7M0 = 0x00;   //设置为准双向口
	
	  IT0 = 1;                                    //使能INT0下降沿中断
    EX0 = 0; 
}